#! /usr/bin/bash
date

#call directory where outputdata is
cd /location/of/blast/output

#give file name where all BLASToutput names are
outputnames='BLASToutputnames.txt'
outputlines=`cat $outputnames`
#give file name where all original file names are
fastanames=‘originalfilenames.txt'
fastalines=`cat $fastanames`

#Sorts BLAST output (format 6) and selects best hit
for line in $outputlines ; do
        #select best blast hit
        sort -k1,1 -k12,12gr -k11,11g -k3,3gr $line.out | sort -u -k1,1 --merge > $line.out.top_hits
done
date


#Removes sequences less than 90% of the median read length in the BLAST output 
for line in $fastanames ; do
	#Need to input location of the original fasta file so it can iterate over line and determine median length
	MEDIAN=`bioawk/bioawk -c fastx '{ print $name, length($seq) }' location/of/orgininalfastas/$line | sort -k2 -n |  awk '{arr[NR]=$2} END { if (NR%2==1) print arr[(NR+1)/2]; else print (arr[NR/2]+arr[NR/2+1])/2}'`
	#Calculate 90% of the median length of the reads
	MEDIAN2=`echo "scale = 2; $MEDIAN * 90 / 100" |bc`
	#removes hits less than 90% of the median and outputs it to a new file
	awk -v foobar="$MEDIAN2" '($4 > foobar)' $line.out.top_hits > $line.out.top_hits.trim
done
date

